(* ::Package:: *)

BlueGray=RGBColor[.5,.5,.7];
Copper=RGBColor[.75,.4,.2];
Copper2=RGBColor@@({217,135,25}/255.);
Copper1=RGBColor@@({184,115,51}/255.);
Options[PartialSphere]={HoleMesh->{2,5},SolidColor->BlueGray,HoleOpacity->.1,SolidDirectives->{}};
PartialSphere[r_,\[Theta]0_,OptionsPattern[]]:={Join[{OptionValue[SolidColor]},If[Head[OptionValue[SolidDirectives]]===List,OptionValue[SolidDirectives],{OptionValue[SolidDirectives]}],{ParametricPlot3D[r {Sin[\[Theta]] Cos[\[Phi]],Sin[\[Theta]] Sin[\[Phi]],Cos[\[Theta]]},{\[Theta],\[Theta]0,\[Pi]},{\[Phi],0,2 \[Pi]},Mesh->None]//First}],
If[\[Theta]0==0,{},{OptionValue[SolidColor],Opacity[OptionValue[HoleOpacity]],ParametricPlot3D[r {Sin[\[Theta]] Cos[\[Phi]],Sin[\[Theta]] Sin[\[Phi]],Cos[\[Theta]]},{\[Theta],0,\[Theta]0},{\[Phi],0,2 \[Pi]},Mesh->OptionValue[HoleMesh],BoundaryStyle->If[OptionValue[HoleMesh]===None,None,Directive[OptionValue[SolidColor]]]]//First}]}
Options[PartialCylinder]={HoleMesh->{2,5},SolidColor->BlueGray,HoleOpacity->.1,SolidDirectives->{}};
PartialCylinder[r_,L_,\[Theta]0_,OptionsPattern[]]:={Join[{OptionValue[SolidColor]},If[Head[OptionValue[SolidDirectives]]===List,OptionValue[SolidDirectives],{OptionValue[SolidDirectives]}],{ParametricPlot3D[{x,r Sin[\[Theta]] ,r Cos[\[Theta]]},{\[Theta],\[Theta]0,2 \[Pi]-\[Theta]0},{x,-(L/2),L/2},Mesh->None]//First}],
If[\[Theta]0==0,{},{OptionValue[SolidColor],Opacity[OptionValue[HoleOpacity]],ParametricPlot3D[{x,r Sin[\[Theta]] ,r Cos[\[Theta]]},{\[Theta],-\[Theta]0,\[Theta]0},{x,-(L/2),L/2},Mesh->OptionValue[HoleMesh],BoundaryStyle->If[OptionValue[HoleMesh]===None,None,Directive[OptionValue[SolidColor]]]]//First}]}
Cone[{r0_,r1_},\[Theta]_,OptionsPattern[PartialSphere]]:=
If[\[Theta]==\[Pi],{},Join[{OptionValue[SolidColor]},If[Head[OptionValue[SolidDirectives]]===List,OptionValue[SolidDirectives],{OptionValue[SolidDirectives]}],{ParametricPlot3D[r {Sin[\[Theta]] Cos[\[Phi]],Sin[\[Theta]] Sin[\[Phi]],Cos[\[Theta]]},{r,r0,r1},{\[Phi],0,2 \[Pi]},Mesh->None]//First}]]
Cone[r_?NumericQ,\[Theta]0_,opts___]:=Cone[{0,r},\[Theta]0,opts]
AngledWedge[{r0_,r1_},L_,\[Theta]_,OptionsPattern[PartialCylinder]]:=
If[\[Theta]==\[Pi],{},Join[{OptionValue[SolidColor]},If[Head[OptionValue[SolidDirectives]]===List,OptionValue[SolidDirectives],{OptionValue[SolidDirectives]}],{ParametricPlot3D[{{x,r Sin[\[Theta]] ,r Cos[\[Theta]]},{x,-r Sin[\[Theta]] ,r Cos[\[Theta]]}},{r,r0,r1},{x,-(L/2),L/2},Mesh->None]//First}]]
AngledWedge[r_?NumericQ,L_,\[Theta]0_,opts___]:=AngledWedge[{0,r},L,\[Theta]0,opts]
ConductorOptions={SolidColor->Copper,SolidDirectives->Specularity[1,30]};
ConductorOptions1={SolidColor->Copper1,SolidDirectives->Specularity[1,30]};
ConductorOptions2={SolidColor->Copper2,SolidDirectives->Specularity[1,30]};
PartialSolidSphere[r_?NumericQ,\[Theta]0_,opts___]:={PartialSphere[r,\[Theta]0,opts],Cone[{0,r},\[Theta]0,opts]}
PartialSolidSphere[{r1_,r2_},\[Theta]0_,opts___]:={PartialSphere[r1,\[Theta]0,opts],PartialSphere[r2,\[Theta]0,opts],Cone[{r1,r2},\[Theta]0,opts]}
PartialSolidCylinder[r_?NumericQ,L_,\[Theta]0_,opts___]:={PartialCylinder[r,L,\[Theta]0,opts],AngledWedge[{0,r},L,\[Theta]0,opts]}
PartialSolidCylinder[{r1_,r2_},L_,\[Theta]0_,opts___]:={PartialCylinder[r1,L,\[Theta]0,opts],PartialCylinder[r2,L,\[Theta]0,opts],AngledWedge[{r1,r2},L,\[Theta]0,opts]}
